﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using N3;

namespace UnitTestProject
{
    [TestClass]
    public class UnitTest1
    {        
        [TestMethod]
        public void TestMethod_AreNotEqual_true()
        {
            // метод, проверяющий, что фактический результат не равен ожидаемому
            float expected = 20;
            float actual = OperationClass.quotient(20, 2);
            Assert.AreNotEqual(expected, actual);
        }

        [TestMethod]
        public void TestMethod_AreNotEqual_true2()
        {
            // метод, проверяющий, что фактический результат не равен ожидаемому
            float expected = 20;
            float actual = OperationClass.product(20, 2);
            Assert.AreNotEqual(expected, actual);
        }

        [TestMethod]
        public void TestMethod_AreEqual_true()
        {
            // метод, проверяющий, что фактический результат не равен ожидаемому
            float expected = 22;
            float actual = OperationClass.sum(20, 2);
            Assert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void TestMethod_IsNotNull_true2()
        {
            // метод, проверяющий, что фактический результат не равен NULL
            float actual = OperationClass.logorifm(10);
            Assert.IsNotNull(actual);
        }

        [TestMethod]
        public void TestMethod_IsTrue_true()
        {
            // метод, проверяющий, что фактический результат равен ожидаемому
            float expected = 6;
            float actual = OperationClass.difference(8, 2);
            Assert.IsTrue(expected == actual);
        }

        [TestMethod]
        public void TestMethod_IsTrue_false()
        {
            // метод, проверяющий, что фактический результат равен ожидаемому
            float expected = 6;
            float actual = OperationClass.power(4);
            Assert.IsTrue(expected != actual);
        }

        [TestMethod]
        public void TestMethod_isFalse_true()
        {
            // метод, проверяющий, что фактический результат не равен ожидаемому
            float expected = 3;
            float actual = OperationClass.extract(4);
            Assert.IsFalse(expected == actual);
        }

        [TestMethod]
        public void TestMethod_IsInstanceOfType_true()
        {
            // метод, проверяющий, что фактический тип ответа равен ожидаемому
            float actual = OperationClass.sinus(4);
            Assert.IsInstanceOfType(actual, typeof(float));
        }

        [TestMethod]
        public void TestMethod_IsNotInstanceOfType_true()
        {
            // метод, проверяющий, что фактический тип ответа не равен ожидаемому
            float actual = OperationClass.cotangent(4);
            Assert.IsNotInstanceOfType(actual, typeof(int));
        }

        [TestMethod]
        public void TestMethod_IsNotNull_true()
        {
            // метод, проверяющий, что фактический ответ не равен NULL
            float actual = OperationClass.procent(-10,100);
            Assert.IsNotNull(actual);
        }

        [TestMethod]
        public void TestMethodThrowException_1()
        {
            //ошибка пустого значения
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => OperationClass.sum(Convert.ToInt32(null), 5)));
        }

        [TestMethod]
        public void TestMethodThrowException_2()
        {
            //ошибка выхода за границы
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => OperationClass.sum((float)3000000000, 5)));
        }

        [TestMethod]
        public void TestMethodThrowException_3()
        {
            //ошибка деления на 0
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => OperationClass.quotient(10,0)));
        }

        [TestMethod]
        public void TestMethodThrowException_4()
        {
            //ошибка отрицательного логарифма
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => OperationClass.logorifm(-1540)));
        }

        [TestMethod]
        public void TestMethodThrowException_5()
        {
            //ошибка отрицательного логарифма
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => OperationClass.cotangent(-1000)));
        }
    }
}
